diff --git a/src/backend/access/transam/xlog.c b/src/backend/access/transam/xlog.c
index acd95aa..3d88727 100644
--- a/src/backend/access/transam/xlog.c
+++ b/src/backend/access/transam/xlog.c
@@ -5930,6 +5930,18 @@ StartupXLOG(void)
 	struct stat st;
 
 	/*
+	 * Prevent standalone process to start if recovery is wanted. A lot of
+	 * code paths in recovery depend on the assumption that it is not the
+	 * case.
+	 */
+	if (!IsPostmasterEnvironment)
+	{
+		if (stat(RECOVERY_COMMAND_FILE, &st) == 0)
+			ereport(FATAL,
+					(errmsg("recovery.conf is not allowed with a standalone process")));
+	}
+
+	/*
 	 * Read control file and check XLOG status looks valid.
 	 *
 	 * Note: in most control paths, *ControlFile is already valid and we need
